library SimpleBotPas;

uses
  SysUtils, Classes, Windows, FortressCommonDefs;

{$R *.res}

function GetName:PChar; stdcall; export;
begin
  Result:='SimpleBot v1.2 (Pascal)';
end;

const
  STRATEGY:array[0..MaxProjectsToPLayer-1] of integer =
  (
   5, 6, 11, 13, 16, 18, 20, 29, 31, 33, 34, 35, 44, 45, 46
   );                  

function StartGame(aPlayerNumber:integer; aAvailProjects: PAvailProjects; AGI:PAdditionalGameInfo):integer; stdcall;export;
var
  _i:integer;
begin
  if aAvailProjects=nil then exit;
  for _i:=0 to MaxProjectsToPLayer-1 do
   aAvailProjects^[_i]:=STRATEGY[_i];
end;

function IsProjectAvail(aProject:integer;aAvailProjects: PAvailProjects):boolean;
var
  _i:integer;
begin
  Result:=false;
  for _i:=0 to MaxProjectsToPLayer-1 do
   if aAvailProjects^[_i]=aProject then
    begin
     Result:=true;
     exit;
    end;
end;

const
  BuildBatteryProject = 33;
  BuildMineProject = 34;
  BuildLabProject = 35;

function GetTurn(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<25) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=18;
    exit;
   end;

  if IsProjectAvail(16,aAvailProjects) and
     (aGame[aPlayerNumber].Shield<5) then
   begin
    Result:=16;
    exit;
   end;

  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<3) and
     (aGame[aPlayerNumber].Base>25) then
   begin
    Result:=BuildMineProject;
    exit;
   end;

  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Battery<4) and
     (aGame[aPlayerNumber].Base>25) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;

  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<3) and
     (aGame[aPlayerNumber].Base>25) then
   begin
    Result:=BuildLabProject;
    exit;
   end;

  //  
  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Battery<7) and
     (aGame[aPlayerNumber].Base>40) and
     (aGame[aPlayerNumber].Shield>10) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;

  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<6) and
     (aGame[aPlayerNumber].Base>40) and
     (aGame[aPlayerNumber].Shield>10) then
   begin
    Result:=BuildMineProject;
    exit;
   end;   

  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<5) and
     (aGame[aPlayerNumber].Base>40) then
   begin
    Result:=BuildLabProject;
    exit;
   end;
       //

   //----------
  if IsProjectAvail(31,aAvailProjects) then
   begin
    Result:=31;
    exit;
   end;

  if IsProjectAvail(46,aAvailProjects) then
   begin
    Result:=46;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) then
   begin
    Result:=29;
    exit;
   end;
   /////

  if IsProjectAvail(45,aAvailProjects) and
     (aGame[_OPP].Battery>3) then
   begin
    Result:=45;
    exit;
   end;

  if IsProjectAvail(44,aAvailProjects) and
     (aGame[_OPP].Mines>2) then
   begin
    Result:=44;
    exit;
   end;

  repeat
   Result:=aAvailProjects^[random(8)];
  until Result<>0;
end;

exports
  GetName, GetTurn, StartGame;

begin

end.
 